// GridDialog.cpp : implementation file
//

#include <afxres.h>
#include <afxext.h>         // MFC extensions
#include <afxcmn.h>			// MFC support for Windows Common Controls
#include "libgfl.h"
#include "libgfle.h"
#include "resource.h"
#include <commctrl.h>
#include "GridDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CGridDialog* grid_dialog;

/////////////////////////////////////////////////////////////////////////////
// CGridDialog dialog


CGridDialog::CGridDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CGridDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGridDialog)
	m_p1_x = 0.0;
	m_p1_y = 0.0;
	m_p2_x = 0.0;
	m_p2_y = 0.0;
	m_p3_x = 0.0;
	m_p3_y = 0.0;
	m_horz_steps = 0;
	m_vert_steps = 0;
	//}}AFX_DATA_INIT
}


void CGridDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGridDialog)
	DDX_Text(pDX, IDC_EDIT_P1X, m_p1_x);
	DDX_Text(pDX, IDC_EDIT_P1Y, m_p1_y);
	DDX_Text(pDX, IDC_EDIT_P2X, m_p2_x);
	DDX_Text(pDX, IDC_EDIT_P2Y, m_p2_y);
	DDX_Text(pDX, IDC_EDIT_P3X, m_p3_x);
	DDX_Text(pDX, IDC_EDIT_P3Y, m_p3_y);
	DDX_Text(pDX, IDC_EDIT_HORZ_STEPS, m_horz_steps);
	DDX_Text(pDX, IDC_EDIT_VERT_STEPS, m_vert_steps);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGridDialog, CDialog)
	//{{AFX_MSG_MAP(CGridDialog)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridDialog message handlers

void CGridDialog::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::PostNcDestroy();
    //GetParent()->PostMessage(WM_MODELESS_CLOSED,0,0);
    delete this;
	grid_dialog = 0;
}

void CGridDialog::OnCancel() 
{
	DestroyWindow();
}

void CGridDialog::OnOK() 
{
    if (UpdateData(true))
    {
		if (m_horz_steps > 0 && m_vert_steps > 0)
			rasterize(m_p1_x, m_p1_y,
					  m_p2_x, m_p2_y,
					  m_p3_x, m_p3_y,
					  m_horz_steps, m_vert_steps);
		else
			MessageBox( "Steps need to be positive", "Error", MB_OK ); 
	}
}

void CGridDialog::OnClear() 
{
	clearResult();
}
